/*
 *  galculator.h - general definitions.
 *	part of galculator
 *  	(c) 2002-2003 Simon Floery (simon.floery@gmx.at)
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Library General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

#ifndef _GALCULATOR_H
#define _GALCULATOR_H 1

/* get it from automake */
#define PROG_NAME PACKAGE
#define PROG_VERSION VERSION	

#define DEFAULT_DEC_POINT '.'

#define CONFIG_FILE_NAME ".galculator"

#define MY_INFINITY_STRING "inf"

// also change this in calc_basic.h
#define BUG_REPORT	"Please submit a bugreport."

/* if we do not get infinity from math.h, we try to define it by ourselves */
#include <math.h>
#ifndef INFINITY
	#define INFINITY 1.0 / 0.0
#endif

#include <glib.h>

/* CS_xxxx define flags for current_status. */

enum {
	CS_DEC,
	CS_HEX,
	CS_OCT,
	CS_BIN,
	NR_NUMBER_BASES
};

enum {
	CS_DEG,
	CS_RAD,
	CS_GRAD,
	NR_ANGLE_BASES
};

enum {
	CS_PAN,		/* __P__seudo __A__lgebraic __N__otation */
	CS_RPN,		/* reverse polish notation */
	NR_NOTATION_MODES
};

enum {
	CS_FMOD_FLAG_INV,
	CS_FMOD_FLAG_HYP
};

typedef struct {
	unsigned char	number:2;
	unsigned char	angle:2;
	unsigned char	notation:1;
	unsigned char	fmod:2;
} s_current_status;

typedef struct {
	char		*button_label;
	double		(*func[4])(double);
} s_function_list;

typedef struct {
	char		*button_label;
	double		constant;
} s_constant_list;

typedef struct {
	char		*button_label;
	void		(*func)();
} s_gfunc_list;

typedef struct {
	char		*button_label;
	char		operation;
} s_operation_map;

typedef struct {
	int			x;
	int			y;
} s_point;

typedef struct {
	char		*button_name;
	gboolean	number_active[NR_NUMBER_BASES];
	gboolean	notation_active[NR_NOTATION_MODES];
} s_active_buttons;

#endif /* galculator.h */
