/*
 *  general_functions.h
 *	part of galculator
 *  	(c) 2002-2003 Simon Floery (simon.floery@gmx.at)
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Library General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

#ifndef _GENERAL_FUNCTIONS_H
#define _GENERAL_FUNCTIONS_H 1

#include "config_file.h"

#define BIT(val, index) ((val & (1 << index)) >> index)

void statusbar_init (GtkWidget *a_parent_widget);
double error_unsupported_inv (double dummy);
double error_unsupported_hyp (double dummy);
void error_message (char *message);
void clear ();
void all_clear ();
void memory_update_tooltips ();
void memory_save ();
void memory_read ();
void memory_add2mem ();

void set_button_group_size (GtkWidget *a_parent_widget, char *table_name, int width, int height);
void set_button_group_font (GtkWidget *a_parent_widget, char *table_name, char *font_string);

double axtof (char *bin_string, int base, int dlength);
char *ftoax (double x, int base, int dlength);

void set_button_label (GtkWidget *a_parent_widget, char *button_name, void *new_label);
void set_checkbutton (GtkWidget *a_parent_widget, char *checkbutton_name, void *checked);
void set_spinbutton (GtkWidget *a_parent_widget, char *spinbutton_name, void *value);
void set_optmenu (GtkWidget *a_parent_widget, char *optmenu_name, void *index);
gboolean da_expose_event_cb(GtkWidget *widget, GdkEventExpose *event, gpointer data);
void set_button_color (GtkWidget *a_parent_widget, char *button_name, void *color_string);

char *gdk_color_to_string (GdkColor color);
GtkWidget *show_font_dialog (char *title, GtkButton *button);
GtkWidget *show_color_dialog (char *title, GtkButton *button);

void get_button_color (GtkWidget *a_parent_widget, char *button_name, void **string_color);
void get_button_label (GtkWidget *a_parent_widget, char *button_name, void **);
void get_checkbutton (GtkWidget *a_parent_widget, char *name, void **is_active);
void get_spinbutton (GtkWidget *a_parent_widget, char *name, void **);
void get_optmenu (GtkWidget *a_parent_widget, char *name, void **);

void update_all (GtkWidget *a_parent_widget, s_preferences prefs);
void set_widget_visibility (GtkWidget *a_parent_widget, char *widget_name, gboolean visible);

void gtk_widget_really_modify_fg (GtkWidget *widget, GdkColor color);

void update_active_buttons (GtkWidget *parent_widget, int number_base, int notation_mode);

#endif /* general_functions.h */
